:: Script facilitant la mise en place des pr-requis pour l'utilisation de mods et
:: de Shadow Keeper avec Baldur's Gate Enhanced Edition.
::
:: Historique
:: Version 1
:: - version originale
:: Version 2
:: - correction de la dtection des erreurs de cration de liens
:: - dsactivation de la partie Shadow Keeper
:: Version 3
:: - Reconnaissance de l'excutable sous le nom BGEE.exe pour la version Steam
:: - Ajout de trace sur la version suppose du jeu (Beamdog ou Steam)
@echo off
echo setupBGEEmods version 3

:: Utilisation de l'valuation retarde des variables, ncessaires pour traiter des lments dans des boucles ou de if
:: Dans ce mode, le caractre ! remplace le % habituel pour dsigner les variables
:: Ncessaire pour la modification de Baldur.ini
SETLOCAL ENABLEDELAYEDEXPANSION
:: Command processing extensions are very useful
SETLOCAL EnableExtensions
:: S'assurer de partir du rpertoire local, mme en tant lanc en tant qu'administrateur
:: (en tant qu'administrateur, le rpertoire par dfaut est chang en C:\Windows\system32
@cd /d "%~dp0"

:: Langue par dfaut : en_US
set language=en_US

:: Vrification qu'on est dans le bon environnement :
:: Prsence obligatoire des fichiers chitin.key et Baldur.exe, des rpertoires data, lang, movies et music 
if not exist chitin.key goto RepertoireInvalide
if not exist data goto RepertoireInvalide
if not exist lang goto RepertoireInvalide
if not exist movies goto RepertoireInvalide
if not exist music goto RepertoireInvalide

:: Excutable : soit baldur.exe, soit BGEE.exe (version Steam)
if exist Baldur.exe goto ExecutableBeamdogTrouve
if not exist BGEE.exe goto RepertoireInvalide
echo Version Steam apparemment
goto ExecutableTrouve

:ExecutableBeamdogTrouve
echo Version Beamdog apparemment

:ExecutableTrouve

:: Creer le rpertoire override s'il n'existe pas
if exist override goto override_existe
mkdir override

:override_existe

:: Vrification des versions de Windows pour dterminer si c'est au moins XP ou Vista
:: Code emprunt  BGT

VER |find /i "Windows 95" > NUL
IF NOT ERRORLEVEL 1 GOTO avantXP

VER |find /i "Windows 98" > NUL
IF NOT ERRORLEVEL 1 GOTO avantXP

VER |find /i "Windows Millennium" > NUL
IF NOT ERRORLEVEL 1 GOTO avantXP

VER | find "NT" > nul
IF %errorlevel% EQU 0 GOTO avantXP

VER | find "XP" > nul
IF %errorlevel% EQU 0 GOTO versionXP

VER | find "2000" > nul
IF %errorlevel% EQU 0 GOTO avantXP

:: Windows Server 2003 ?
VER | find "Version 5.2" > nul
IF %errorlevel% EQU 0 GOTO versionXP

VER | find "Version 6.0" > nul
IF %errorlevel% EQU 0 GOTO versionVistaouPlus

VER | find "Version 6.1" > nul
IF %errorlevel% EQU 0 GOTO versionVistaouPlus

:: Hypothse : Windows suprieur ou gal  Vista si aucun test n'a russi (par exemple Windows 8)
goto versionVistaouPlus

:avantXP
echo Impossible de creer des liens avec les versions de Windows anterieures a XP.
echo L'utilisation de mods necessite des operations manuelles.
echo.
pause
exit

:versionXP

set WindowsXP=1

goto Suite

:versionVistaouPlus

set WindowsXP=0

goto Suite

:Suite

:: Dtermination de l'environnement Mes documents (variable selon la version de Windows)
set BGEE_doc=""
if exist "%userprofile%\Mes documents\Baldur's Gate - Enhanced Edition" set BGEE_doc="%userprofile%\Mes documents\Baldur's Gate - Enhanced Edition"
if exist "%userprofile%\Documents\Baldur's Gate - Enhanced Edition" set BGEE_doc="%userprofile%\Documents\Baldur's Gate - Enhanced Edition"

if %BGEE_doc% EQU "" goto MesDocsNonTrouve

set fichierIni=%BGEE_doc%\Baldur.ini

:: Determination de la langue utilise dans le jeu
:: On cherche la ligne <tab>'Language',<tab>'Text',<tab>'fr_FR',
for /F "tokens=1-3 delims=,	'" %%a in ('type %fichierIni%') do (
  if "%%a" EQU "Language" (
    set language=%%c
  )
)

if exist dialog.tlk del dialog.tlk
if exist dialogF.tlk del dialogF.tlk

if %WindowsXP% EQU 1 (
  fsutil hardlink create dialog.tlk .\lang\%language%\dialog.tlk
  IF ERRORLEVEL 1 GOTO erreurLien
  if exist .\lang\%language%\dialogF.tlk (
    fsutil hardlink create dialogF.tlk .\lang\%language%\dialogF.tlk
    IF ERRORLEVEL 1 GOTO erreurLien
  )
) else (
  mklink /H dialog.tlk .\lang\%language%\dialog.tlk
  IF ERRORLEVEL 1 GOTO erreurLien
  if exist .\lang\%language%\dialogF.tlk (
    mklink /H dialogF.tlk .\lang\%language%\dialogF.tlk
    IF ERRORLEVEL 1 GOTO erreurLien
  )
)

goto fin

:ConfigShadowKeeper

echo Configuration pour Shadow Keeper

:: Besoins Shadow Keeper : BGMain.exe Baldur.ini + dialog.tlk
:: save, portraits, characters

:: BGMain.exe et Baldur.ini doivent tre prsents, mais leur contenu n'a pas d'importance
:: Shadow Keeper ne doit pas savoir lire le nouveau format de Baldur.ini

if %WindowsXP% EQU 1 (
  echo Liens impossibles a creer sous Windows XP.
  echo Utilisez la methode manuelle de copie des fichiers dans les deux sens.
  echo.
) else (
  if exist BGMain.exe del BGMain.exe
  if exist Baldur.ini del Baldur.ini
  mklink /H BGMain.exe Baldur.exe
  echo. > Baldur.ini
  for %%F in ( save characters Portraits ) do (
    if not exist "%userprofile%\Documents\Baldur's Gate - Enhanced Edition\%%F" (
      mkdir "%userprofile%\Documents\Baldur's Gate - Enhanced Edition\%%F"
    )
    if exist "%userprofile%\Documents\Baldur's Gate - Enhanced Edition\%%F" (
      if exist %%F rmdir %%F
      mklink /D %%F "%userprofile%\Documents\Baldur's Gate - Enhanced Edition\%%F"
      IF ERRORLEVEL 1 GOTO erreurLienSK
    )
  )
)


:fin
pause
exit

:erreurLien
echo Erreur de creation d'un lien :
echo fichier dialog.tlk ou dialogF.tlk absent du repertoire lang\%language% ?
echo.
pause
exit

:erreurLienSK
echo Erreur de creation d'un lien :
echo repertoire save, characters ou portraits absent du repertoire
echo %userprofile%\Documents\Baldur's Gate - Enhanced Edition (Vista ou plus rcent)
echo ou
echo %userprofile%\Documents\Baldur's Gate - Enhanced Edition (XP)
echo.
pause
exit

:MesDocsNonTrouve
echo Repertoire "Mes documents\Baldur's Gate - Enhanced Edition" non trouve.
echo Cause possible : version ou langue de Windows non geree par le script.
pause
exit

:RepertoireInvalide
echo Repertoire invalide : fichiers de BGEE absents du repertoire d'execution
echo Fichiers attendus : chitin.key, Baldur.exe (ou BGEE.exe pour Steam)
echo Repertoires attendus : data, lang, movies, music
echo Placez ce fichier dans le repertoire principal du jeu, generalement
echo X:\repertoire\Baldur's Gate Enhanced Edition\Data\00766 pour la version Beamdog
echo X:\repertoire\Baldur's Gate Enhanced Edition pour la version Steam
echo.
pause
exit
